# saga::cpr::service Class Reference

The cpr::service, as a job::service, represents a resource management backend, which additionally offers checkpoint management capabilities. More...

`#include <cpr_job_service.hpp>`

Inheritance diagram for saga::cpr::service:

[legend]

List of all members.

## Public Member Functions
| service (session const &s, saga::url rm=saga::url())
| Creates the object.
| service (saga::url rm=saga::url())
| Creates the object.
| service (saga::object const &o)
| Creates the object.
| ~service (void)
| Destroys the object.
service & | operator= (saga::object const &o)
| Brief description starts here.
saga::cpr::job | create_job (saga::cpr::description job_desc)
| Create a job instance.
saga::cpr::job | create_job (saga::cpr::description job_desc, saga::cpr::description restart_desc)
| Create a job instance.
saga::cpr::job | run_job (std::string cmd, std::string host, saga::job::ostream &in, saga::job::istream &out, saga::job::istream &err)
| Run a command synchronously.
saga::cpr::job | run_job (std::string cmd, std::string host)
## Static Public Member Functions
static service | create (session const &s, saga::url rm=saga::url())
| Factory function resembling service(session, url) constructor.
static service | create (saga::url rm=saga::url())
| Factory function resembling service(url, int) constructor.
template<typename Tag>
static saga::task | create (saga::url rm=saga::url())
| Factory function resembling service(url, int) constructor.

## Detailed Description

The cpr::service, as a job::service, represents a resource management backend, which additionally offers checkpoint management capabilities.

## Constructor & Destructor Documentation

saga::cpr::service::service | ( | session const & | s,
|  | saga::url | rm = `saga::url()` |
| ) |  |  | `[explicit]`

Creates the object.

Reimplemented from saga::job::service.

saga::cpr::service::service | ( | saga::url | rm = `saga::url()` | ) | `[explicit]`

Creates the object.

Reimplemented from saga::job::service.

saga::cpr::service::service | ( | saga::object const & | o | ) | `[explicit]`

Creates the object.

Reimplemented from saga::job::service.

References saga::BadParameter, saga::object::CPRJobService, and saga::object::get_type().

saga::cpr::service::~service | ( | void |  | ) |

Destroys the object.

Reimplemented from saga::job::service.

## Member Function Documentation

static service saga::cpr::service::create | ( | session const & | s,
|  | saga::url | rm = `saga::url()` |
| ) |  |  | `[inline, static]`

Factory function resembling service(session, url) constructor.

Reimplemented from saga::job::service.

static service saga::cpr::service::create | ( | saga::url | rm = `saga::url()` | ) | `[inline, static]`

Factory function resembling service(url, int) constructor.

Reimplemented from saga::job::service.

template<typename Tag>

static saga::task saga::cpr::service::create | ( | saga::url | rm = `saga::url()` | ) | `[inline, static]`

Factory function resembling service(url, int) constructor.

Reimplemented from saga::job::service.

service & saga::cpr::service::operator= | ( | saga::object const & | o | ) |

Brief description starts here.

Reimplemented from saga::job::service.

saga::cpr::job saga::cpr::service::create_job | ( | saga::cpr::description | job_desc | ) | `[inline]`

Create a job instance.

Parameters:

  | job_desc | Description of job to be submitted

Returns:
  A job object representing the submitted job instance

saga::cpr::job saga::cpr::service::create_job | ( | saga::cpr::description | job_desc,
|  | saga::cpr::description | restart_desc |
| ) |  |  | `[inline]`

Create a job instance.

Parameters:

  | job_desc | Description of job to be submitted
  | restart_desc | Description of job to be used on recovery

Returns:
  A job object representing the submitted job instance

saga::cpr::job saga::cpr::service::run_job | ( | std::string | commandline,
|  | std::string | hostname,
|  | saga::job::ostream & | stdin_stream,
|  | saga::job::istream & | stdout_stream,
|  | saga::job::istream & | stderr_stream |
| ) |  |  | `[inline]`

Run a command synchronously.

Parameters:

  | hostname | Hostname to be used by rm for submission
  | commandline | The command and arguments to be run

Reimplemented from saga::job::service.

saga::cpr::job saga::cpr::service::run_job | ( | std::string | cmd,
|  | std::string | host |
| ) |  |  | `[inline]`

Reimplemented from saga::job::service.

The documentation for this class was generated from the following files:

- cpr_job_service.hpp
- cpr_job_service.cpp